# Class Certificate

java.lang.Object
javax.security.cert.Certificate

Direct Known Subclasses:
  `X509Certificate`

@Deprecated(since="9", forRemoval=true) public abstract class Certificate extends Object
Deprecated, for removal: This API element is subject to removal in a future version.
Use the classes in `java.security.cert` instead.

Abstract class for managing a variety of identity certificates. An identity certificate is a guarantee by a principal that a public key is that of another principal. (A principal represents an entity such as an individual user, a group, or a corporation.)

This class is an abstraction for certificates that have different formats but important common uses. For example, different types of certificates, such as X.509 and PGP, share general certificate functionality (like encoding and verifying) and some types of information (like a public key).

X.509, PGP, and SDSI certificates can all be implemented by subclassing the Certificate class, even though they contain different sets of information, and they store and retrieve the information in different ways.

Note: The classes in the package `javax.security.cert` exist for compatibility with earlier versions of the Java Secure Sockets Extension (JSSE). New applications should instead use the standard Java SE certificate classes located in `java.security.cert`.

Since:
  1.4
See Also:
  - `X509Certificate`

## Constructor Summary

Constructors
Constructor
Description
`Certificate()`
Deprecated, for removal: This API element is subject to removal in a future version.
Constructor for subclasses to call.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`equals(Object obj)`
Deprecated, for removal: This API element is subject to removal in a future version.
Compares this certificate for equality with the specified object.
`abstract byte[]`
`getEncoded()`
Deprecated, for removal: This API element is subject to removal in a future version.
Returns the encoded form of this certificate.
`abstract PublicKey`
`getPublicKey()`
Deprecated, for removal: This API element is subject to removal in a future version.
Gets the public key from this certificate.
`int`
`hashCode()`
Deprecated, for removal: This API element is subject to removal in a future version.
Returns a hashcode value for this certificate from its encoded form.
`abstract String`
`toString()`
Deprecated, for removal: This API element is subject to removal in a future version.
Returns a string representation of this certificate.
`abstract void`
`verify(PublicKey key)`
Deprecated, for removal: This API element is subject to removal in a future version.
Verifies that this certificate was signed using the private key that corresponds to the specified public key.
`abstract void`
`verify(PublicKey key, String sigProvider)`
Deprecated, for removal: This API element is subject to removal in a future version.
Verifies that this certificate was signed using the private key that corresponds to the specified public key.

### Methods declared in class Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Constructor Details

### Certificate

public Certificate()
Deprecated, for removal: This API element is subject to removal in a future version.
Constructor for subclasses to call.

## Method Details

### equals

public boolean equals(Object obj)
Deprecated, for removal: This API element is subject to removal in a future version.
Compares this certificate for equality with the specified object. If the `obj` object is an `instanceof` `Certificate`, then its encoded form is retrieved and compared with the encoded form of this certificate.

Overrides:
  `equals` in class `Object`
Parameters:
  `obj` - the object to test for equality with this certificate.
Returns:
  true if the encoded forms of the two certificates match, false otherwise.
See Also:
  - `Object.hashCode()`
  - `HashMap`

### hashCode

public int hashCode()
Deprecated, for removal: This API element is subject to removal in a future version.
Returns a hashcode value for this certificate from its encoded form.

Overrides:
  `hashCode` in class `Object`
Returns:
  a hashcode value for this certificate from its encoded form
See Also:
  - `Object.equals(java.lang.Object)`
  - `System.identityHashCode(Object)`

### getEncoded

public abstract byte[] getEncoded() throws CertificateEncodingException
Deprecated, for removal: This API element is subject to removal in a future version.
Returns the encoded form of this certificate. It is assumed that each certificate type would have only a single form of encoding; for example, X.509 certificates would be encoded as ASN.1 DER.

Returns:
  encoded form of this certificate
Throws:
  `CertificateEncodingException` - on internal certificate encoding failure

### verify

public abstract void verify(PublicKey key) throws CertificateException, NoSuchAlgorithmException, InvalidKeyException, NoSuchProviderException, SignatureException
Deprecated, for removal: This API element is subject to removal in a future version.
Verifies that this certificate was signed using the private key that corresponds to the specified public key.

Parameters:
  `key` - the PublicKey used to carry out the verification.
Throws:
  `NoSuchAlgorithmException` - on unsupported signature algorithms.
  `InvalidKeyException` - on incorrect key.
  `NoSuchProviderException` - if there's no default provider.
  `SignatureException` - on signature errors.
  `CertificateException` - on encoding errors.

### verify

public abstract void verify(PublicKey key, String sigProvider) throws CertificateException, NoSuchAlgorithmException, InvalidKeyException, NoSuchProviderException, SignatureException
Deprecated, for removal: This API element is subject to removal in a future version.
Verifies that this certificate was signed using the private key that corresponds to the specified public key. This method uses the signature verification engine supplied by the specified provider.

Parameters:
  `key` - the PublicKey used to carry out the verification.
  `sigProvider` - the name of the signature provider.
Throws:
  `NoSuchAlgorithmException` - on unsupported signature algorithms.
  `InvalidKeyException` - on incorrect key.
  `NoSuchProviderException` - on incorrect provider.
  `SignatureException` - on signature errors.
  `CertificateException` - on encoding errors.

### toString

public abstract String toString()
Deprecated, for removal: This API element is subject to removal in a future version.
Returns a string representation of this certificate.

Overrides:
  `toString` in class `Object`
Returns:
  a string representation of this certificate.

### getPublicKey

public abstract PublicKey getPublicKey()
Deprecated, for removal: This API element is subject to removal in a future version.
Gets the public key from this certificate.

Returns:
  the public key.